# Synthesis of vowels with the same formants as in IPA recordings

setwd('/home/allgoodguys/Documents/Studying/Lund_PhD/experiments/colors-and-sounds/Niklas_data')

library(soundgen)

ipa = read.csv('ipa_audio.csv')
ipa = ipa[!is.na(ipa$F1), ]  # vowels only
ipa$vtl[!is.na(ipa$F1)] = apply(ipa[!is.na(ipa$F1), c('F1', 'F2', 'F3', 'F4', 'F5', 'F6')], 1, function(x) schwa(formants = x)$vtl)
ipa[, c('ipa', 'vtl')]

a = analyze('ipa_audio_AA/012_[ə].wav', ylim = c(0, 5), nFormants = 6)
p = a$pitch[!is.na(a$pitch)]
a$f4_freq  # 4500
a$f5_freq  # 5400
a$f6_freq  # 7600

for (i in 1:nrow(ipa)) {
  s = soundgen(
    sylLen = 600,
    pitchAnchors = c(235, 160),
    rolloff = -12,
    noiseAnchors = c(-50, -60),
    rolloffNoise = -9,
    temperature = .001,
    formants = c(ipa$F1[i], ipa$F2[i], ipa$F3[i], ipa$F4[i], ipa$F5[i], ipa$F6[i]),
    amplAnchors = c(0, -10),
    attackLen = 100,
    samplingRate = 44100,
    throwaway = -120,
    play = TRUE
  )
  spectrogram(s, 44100, ylim = c(0, 8), osc = TRUE)
  seewave::savewav(s, f = 44100, filename = paste0('soundgen_audio/', ipa$sound[i]))
}

